var locale = 'en';
var url = 'https://app.puzzley.ir';
var online = true,
    show_ad = true,
    isDevice = false,
    check = false,
    phone_id = '',
    default_access_page = [],
    $app_sl = 'eyJpdiI6InBNYlVrVDZMM2tma1BlVmlVV0I0aUE9PSIsInZhbHVlIjoiVkNHSXdDellhVnZjemlMNjZJQlZPZXhIZDVcLytaTmM3Z2lyWjdyUW9LVms9IiwibWFjIjoiYWY4ODBmNzE1MTgxODJlZjRhMzNiZjIyZGJkYjJlOTkyNjE3MDgzZGVhMjZlNTU5NjcyNDZiYTMwODY2ZGM3MyJ9';

var ngApp = angular.module('ngApp', ['ionic', 'ngResource', 'ngApp.controllers', 'ngApp.services' , 'ionic-datepicker'])
    .run(function($ionicPlatform, $rootScope, $ionicLoading, $ionicHistory, $ionicPopup, $state , Auth) {
        $rootScope.$on('loading:show', function() {
            $ionicLoading.show({
                noBackdrop: true
            });
        });

        $rootScope.$on('loading:hide', function() {
            $ionicLoading.hide();
        });

        $rootScope.dataTapStatus = false;

        $ionicPlatform.ready(function() {
            /*Auth.init();*/
                    });

        $rootScope.backButtonPressedOnceToExit = false;
        $ionicPlatform.registerBackButtonAction(function(e) {
            window.history.back();
            if (window.location.hash.indexOf("web-page") !== -1) { 
                return;
            } else if ($rootScope.backButtonPressedOnceToExit) {
                ionic.Platform.exitApp(); 
            } else if ($ionicHistory.backView()) {
                $ionicHistory.goBack();
            } else if (hasHome && window.location.hash != homeHash) {
                $ionicHistory.nextViewOptions({
                    disableBack: true
                });
                window.location.hash = homeHash;
            } else {
                $rootScope.backButtonPressedOnceToExit = true;
                window.plugins.toast.showWithOptions({
                    message: "برای خروج دوباره کلیک کنید",
                    duration: "short",
                    position: "bottom",
                    addPixelsY: -50
                });
                setTimeout(function() {
                    $rootScope.backButtonPressedOnceToExit = false;
                }, 2500);
            }
            e.preventDefault();
            return false;
        }, 101);

        
                    $rootScope.$on('$stateChangeStart', function(event, toState, toStateParams, fromState, fromStateParams) {
                                                if ((toState.pageid != 1 && !Auth.CanAccess(toState.pageid)) || (typeof toStateParams.id !== 'undefined' && toStateParams.id != 1 && !Auth.CanAccess(toStateParams.id) && toStateParams.func == 'getIndex')) {
                    event.preventDefault();
                    if(Auth.Check()) {
                        $ionicLoading.show({
                            template:'<div class="info"><i class="icon warning ion-ios-information-outline"></i></div><div>شما به این صفحه دسترسی ندارید</div>'
                        });
                        setTimeout(function () {
                            $ionicLoading.hide();
                        }, 2000);
                    } else {
                        $ionicPopup.confirm({
                            cssClass: 'signup_pupop',
                            title: 'ثبت نام',
                            template: 'برای دسترسی به این صفحه باید ثبت نام کنید',
                            okText: 'ورود',
                            okType: 'button-clear button-balanced',
                            cancelText: 'انصراف',
                            cancelType: 'button-clear button-assertive',
                        }).then(function(confirm) {
                            if (confirm) {
                                $state.go('nav.signup448');
                            }
                        });
                    }
                }                    
                            });
            })

    .config(function($stateProvider, $locationProvider, $urlRouterProvider, $ionicConfigProvider, $httpProvider) {

                    $ionicConfigProvider.scrolling.jsScrolling(false);
            $ionicConfigProvider.views.transition('none');
        
        $ionicConfigProvider.templates.maxPrefetch(0);
        $ionicConfigProvider.backButton.previousTitleText(false).text('');
        $ionicConfigProvider.navBar.positionSecondaryButtons('right');
        $ionicConfigProvider.navBar.positionPrimaryButtons('left');

        $httpProvider.interceptors.push(function($rootScope, $q) {
            return {
                /* http request show loading */
                request: function(config) {
                    if (typeof config.noLoading == "undefined" || config.noLoading != true) {
                        $rootScope.$broadcast('loading:show');
                    }
                    return config
                },
                /* Hide loading in case any occurred */
                requestError: function(response) {
                    $rootScope.$broadcast('loading:hide');
                    return response
                },
                /* Hide loading once got response */
                response: function(response) {
                    $rootScope.$broadcast('loading:hide');
                    return response
                },
                /* Hide loading if got any response error  */
                responseError: function(response) {
                    $rootScope.$broadcast('loading:hide');
                    return $q.reject(response);
                }
            }
        });

        
        $ionicConfigProvider.navBar.alignTitle('center');

        $stateProvider
            .state('nav', {
                url: '/nav',
                abstract: true,
                templateUrl: 'nav.html',
                controller: 'NavCtrl',
                secured: 0,
                pageid: 1
            })
            .state('nav.widget1', {
                url: '/widget/:widget/:func/:sl/:id',
                views: {
                    'mainContent': {
                        templateUrl: function(params) {
                            return url + '/api/v1/widget/route/' + params.widget + '/' + params.func + '/' + params.sl + '/' + params.id;
                        }
                    }
                },
                secured: 0,
                pageid: 1
            })
            .state('nav.widget2', {
                url: '/widget/:widget/:func/:sl/:id/:extra',
                views: {
                    'mainContent': {
                        templateUrl: function(params) {
                            return url + '/api/v1/widget/route/' + params.widget + '/' + params.func + '/' + params.sl + '/' + params.id + '/' + params.extra;
                        }
                    }
                },
                secured: 0,
                pageid: 1
            })
            .state('nav.watermarkPage', {
                url: "/watermarkPage",
                views: {
                    'mainContent': {
                        templateUrl: 'appwatermark.html'
                    }
                },
                secured: 0,
                pageid: 1
            })
                        
             .state('nav.home-screen151', { url: '/home-screen151', cache: 'true', secured : 0, pageid : '1', views: { 'mainContent': { templateUrl: 'templates/home-screen151.html' } } })  .state('nav.signup448', { url: '/signup448', cache: 'true', secured : 0, pageid : '1', views: { 'mainContent': { templateUrl: 'templates/signup448.html' } } })  .state('nav.search149', { url: '/search149', cache: 'true', secured : 0, pageid : '402320', views: { 'mainContent': { templateUrl: 'templates/search149.html' } } })  .state('nav.lists893', { url: '/lists893', cache: 'false', secured : 0, pageid : '400801', views: { 'mainContent': { templateUrl: 'templates/lists893.html' } } })  .state('nav.content799', { url: '/content799', cache: 'true', secured : 0, pageid : '400802', views: { 'mainContent': { templateUrl: 'templates/content799.html' } } })  .state('nav.forms613', { url: '/forms613', cache: 'true', secured : 0, pageid : '400806', views: { 'mainContent': { templateUrl: 'templates/forms613.html' } } })  .state('nav.about-us893', { url: '/about-us893', cache: 'true', secured : 0, pageid : '400807', views: { 'mainContent': { templateUrl: 'templates/about-us893.html' } } })  .state('nav.aparat922', { url: '/aparat922', cache: 'true', secured : 0, pageid : '400820', views: { 'mainContent': { templateUrl: 'templates/aparat922.html' } } })  .state('nav.map886', { url: '/map886', cache: 'true', secured : 0, pageid : '402296', views: { 'mainContent': { templateUrl: 'templates/map886.html' } } })  .state('nav.web-page729', { url: '/web-page729', cache: 'true', secured : 0, pageid : '402300', views: { 'mainContent': { templateUrl: 'templates/web-page729.html' } } })  .state('nav.photos885', { url: '/photos885', cache: 'true', secured : 0, pageid : '402305', views: { 'mainContent': { templateUrl: 'templates/photos885.html' } } }) 
        
        
                    .state('nav.puzzleysearch', {
                url: '/puzzleysearch/:widgetslug/:search',
                cache: 'false',
                views: {
                    'mainContent': {
                        templateUrl: function(params) {
                            return 'templates/' + params.widgetslug + '.html';
                        }
                    }
                },
                secured: 0,
                pageid: 1
            })
                ;
        $urlRouterProvider.otherwise('/nav/home-screen151');
    });

    var appsetting = (localStorage.app79157setting) ? JSON.parse(localStorage.app79157setting) : {};
    appsettingInit();

function saveSetting() {
    localStorage.app79157setting = JSON.stringify(appsetting)
}

document.addEventListener("online", function() {
    online = true;
}, false);
document.addEventListener("offline", function() {
    online = false;
}, false);
function isOnline() {
    return online;
}

var homeHash = "#/nav/home-screen151";
var hasHome = true;
/* iap message */
    var signupHash = "#/nav/signup448";

function checkapp() {
    if (!check) {
        check = true;
        $.get(url + '/api/v1/app/check-app/KbAJ')
            .done(function(data) {
                if (typeof(data.active) != 'undefined' && data.active == 0) {
                    alert('این اپلیکیشن غیر فعال است.');
                    window.localStorage['active'] = 'notActive';
                    ionic.Platform.exitApp();
                } else if (typeof(data.active) != 'undefined' && data.active == 1) {
                    window.localStorage['active'] = true;
                }
            }).fail(function() {
                if (window.localStorage['active'] == 'notActive') {
                    alert('این اپلیکیشن غیر فعال است.');
                    ionic.Platform.exitApp();
                }
                check = false;
            });
    }
}
document.addEventListener("deviceready", function() {
    setTimeout(function() {
        if (window.localStorage['active'] == 'notActive') {
            alert('این اپلیکیشن غیر فعال است.');
            ionic.Platform.exitApp();
        }
    }, 10000);
    checkapp();
    document.addEventListener("online", function() {
        checkapp();
    }, false);
    isDevice = true;
});


setTimeout(function(){
    $.ajaxSetup({
        beforeSend: function(xhr) {
            var user = angular.element(document.body).injector().get('$rootScope').user;
            if (user && user.isLogin) {
                var token = user.token;
                if(typeof token != "undefined" && token != '')
                    xhr.setRequestHeader('X-auth-token', token);
            }
        }
    }); 
},3000);

